package szakdolgozat;

import java.awt.geom.Line2D;
import java.awt.geom.Point2D;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.List;

public class FileSaver {
	File filenev;
	List<Object> shapes;
	List<Object> linalakzatok;
	List<Object> nemlinalakzatok;

	private String pointToString(Point2D p){
		String text="";
		return text+"("+p.getX()+","+p.getY()+")";
	}


	public FileSaver(File filenev_, List<Object> alakzatok_, List<Object> linalakzatok_, List<Object> nemlinalakzatok_){
		filenev=filenev_;
		shapes=alakzatok_;
		linalakzatok=linalakzatok_;
		nemlinalakzatok=nemlinalakzatok_;
	}
	public FileSaver(File filenev_, List<Object> alakzatok_){
		filenev=filenev_;
		shapes=new ArrayList<Object>();
		if(alakzatok_!=null){
			for(int i=0;i<alakzatok_.size();i++){
				shapes.add(alakzatok_.get(i));
			}
		}


		linalakzatok=null;
		nemlinalakzatok=null;
	}

	public void writeToFile(){
		boolean isShape=true;
		try{
			FileWriter fstream = new FileWriter(filenev);
			BufferedWriter out = new BufferedWriter(fstream);
			out.write("Point\n");
			int db=0;

			while(isShape){	//kell a !
				isShape=false;
				for(int i=0;i<shapes.size();i++){
					if(shapes.get(i) instanceof Point2D.Double){
						out.write(pointToString(((Point2D.Double)shapes.get(i)))+"\n");
						out.write("*\n");
						isShape=true;
						db++;
						shapes.remove(i);
					}
				}
			}
			if(db==0){
				out.write("*\n");
			}
			out.write("***\n");

			out.write("Line\n");
			db=0;
			isShape=true;
			while(isShape){	//kell a !
				isShape=false;
				for(int i=0;i<shapes.size();i++){
					if(shapes.get(i) instanceof Line2D.Double){
						out.write(pointToString(((Line2D.Double)shapes.get(i)).getP1())+"\n");
						out.write(pointToString(((Line2D.Double)shapes.get(i)).getP2())+"\n");
						out.write("*\n");
						isShape=true;
						db++;
						shapes.remove(i);
					}
				}
			}
			if(db==0){
				out.write("*\n");
			}
			out.write("***\n");



			out.write("Polygon\n");
			db=0;
			isShape=true;
			while(isShape){	//kell a !
				isShape=false;
				for(int i=0;i<shapes.size();i++){
					if(shapes.get(i) instanceof MyPolygon){
						for(int j=0;j<((MyPolygon)shapes.get(i)).pontok.length;j++){
							out.write(pointToString((((MyPolygon)shapes.get(i)).pontok)[j])+"\n");
						}
						out.write("*\n");
						isShape=true;
						db++;
						shapes.remove(i);
					}
				}
			}
			if(db==0){
				out.write("*\n");
			}
			out.write("***\n");

			out.write("Circle\n");
			db=0;
			isShape=true;
			while(isShape){	//kell a !
				isShape=false;
				for(int i=0;i<shapes.size();i++){
					if(shapes.get(i) instanceof MyCircle){
						out.write(pointToString(((MyCircle)shapes.get(i)).O)+"\n");
						out.write(Double.toString(((MyCircle)shapes.get(i)).r)+"\n");
						out.write("*\n");
						isShape=true;
						db++;
						shapes.remove(i);
					}
				}
			}
			if(db==0){
				out.write("*\n");
			}
			out.write("***");


			out.close();

		}catch (Exception e){
			System.err.println("Error: " + e.getMessage());
		}

	}
}
