package szakdolgozat;

import ij.ImagePlus;
import ij.process.ImageProcessor;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;

import javax.swing.BoxLayout;
import javax.swing.GroupLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class ImageToolbarPanel extends JPanel{

	/**
	 * 
	 */
	private static final long serialVersionUID = -7144946100950362731L;
	ImagePanel ip;
	
	public ImageToolbarPanel(final ImagePanel ip) {
		super();
		this.ip=ip;
		setOpaque(true);
		setPreferredSize(new Dimension(250,560));
		
		JLabel c19 = new JLabel("Transzformáció");
		JLabel c20 = new JLabel("Lineáris transzformáció");
		
		JLabel c21 = new JLabel("Mátrix: ");
		final JTextField c22 = new JTextField();
		final JTextField c23 = new JTextField();
		final JTextField c24 = new JTextField();
		final JTextField c25 = new JTextField();
		JButton c26 = new JButton();
		c26.setText("Transzformál");
		c26.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				//Transformation trf=new Transformation();
				if(!c22.getText().equals("") && !c23.getText().equals("") && !c24.getText().equals("") && !c25.getText().equals("")){
					//Transformation transf = new Transformation();
					//trf.linearTransformationPicture(ip., m1, m2, m3, m4);
					if(c22.getText().matches("-?[0-9]+\\.?[0-9]*") && c23.getText().matches("-?[0-9]+\\.?[0-9]*") && c24.getText().matches("-?[0-9]+\\.?[0-9]*")
							&& c25.getText().matches("-?[0-9]+\\.?[0-9]*")){
						String m1=c22.getText();
						String m2=c23.getText();
						String m3=c24.getText();
						String m4=c25.getText();
						ip.linearTransformation(m1,m2,m3,m4);
						ip.setRepairItemEnabled(true);
						ip.repaint();
					}
					
					else {
						JOptionPane.showMessageDialog(ip,
							    "Helytelenül adta meg a mátrixot.",
							    "Mátrix hiba",
							    JOptionPane.ERROR_MESSAGE);
					}
				}
			}
		});
		
		JPanel storagePanel3 = new JPanel();
		storagePanel3.setOpaque(true);
		
		GroupLayout layout3 = new GroupLayout(storagePanel3);
		storagePanel3.setLayout(layout3);
		layout3.setAutoCreateGaps(true);
		layout3.setAutoCreateContainerGaps(true);
		
		layout3.setHorizontalGroup(
				layout3.createSequentialGroup()
				.addGroup(layout3.createParallelGroup(GroupLayout.Alignment.LEADING)
						.addComponent(c21)
						.addComponent(c26)
						)
				.addGroup(layout3.createParallelGroup(GroupLayout.Alignment.LEADING)
						.addComponent(c22)
						.addComponent(c24)
						)
				.addGroup(layout3.createParallelGroup(GroupLayout.Alignment.LEADING)
						.addComponent(c23)
						.addComponent(c25)
						)
				);
		layout3.setVerticalGroup(
				layout3.createSequentialGroup()
				.addGroup(layout3.createParallelGroup(GroupLayout.Alignment.BASELINE)
						.addComponent(c21)
						.addComponent(c22)
						.addComponent(c23)
						)
				.addGroup(layout3.createParallelGroup(GroupLayout.Alignment.BASELINE)
						.addComponent(c24)
						.addComponent(c25)
						)
				.addComponent(c26)
				);

		JLabel c27 = new JLabel("Nemlineáris transzformáció");
		
		JLabel c28 = new JLabel("Képlet:  f(x,y)");
		JLabel c33 = new JLabel("                  g(x,y)");
		c28.setToolTipText("Transzformáció megadása f(x,y) g(x,y) formában.");
		final JTextField c29 = new JTextField();
		c29.setToolTipText("A transzformáció x koordinátára vonatkozó képlete: x'=f(x,y) ");
		final JTextField c30 = new JTextField();
		c30.setToolTipText("A transzformáció y koordinátára vonatkozó képlete: y'=g(x,y) ");
		JButton c31 = new JButton();
		c31.setText("Transzformál");
		
		MyKeyListener mk=new MyKeyListener(c29);
		mk.start();
		MyKeyListener mk2=new MyKeyListener(c30);
		mk2.start();
		
		c31.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				//FRame
				if(!c29.getText().equals("") && !c30.getText().equals("")){
					int szamlalo=0;
					for(int i=0;i<c29.getText().length();i++){
						if(c29.getText().charAt(i)=='('){
							szamlalo++;
						}
						if(c29.getText().charAt(i)==')'){
							szamlalo--;
						}
					}
					if(szamlalo!=0){
						JOptionPane.showMessageDialog(ip,
							    "Hibás zárójelezés f(x,y) megadásakor.",
							    "Zárójel hiba",
							    JOptionPane.ERROR_MESSAGE);
					}
					else{
						szamlalo=0;
						for(int i=0;i<c30.getText().length();i++){
							if(c30.getText().charAt(i)=='('){
								szamlalo++;
							}
							if(c30.getText().charAt(i)==')'){
								szamlalo--;
							}
						}
						if(szamlalo!=0){
							JOptionPane.showMessageDialog(ip,
								    "Hibás zárójelezés g(x,y) megadásakor.",
								    "Zárójel hiba",
								    JOptionPane.ERROR_MESSAGE);
						}
						else{
							Transformation transformer= new Transformation();
							String expression1=c29.getText();
							String expression2=c30.getText();
							if(ip.pictureOnPanel!=null){
								if (ip.pictureOnPanel.getWidth() > 200) {
									JOptionPane.showMessageDialog(ip, "A transzformáció gyors lefutása érdekében a kép kicsinyítésre kerül.");
									ip.pictureOnPanel = resizeImageWithHint(ip.pictureOnPanel,
											ip.pictureOnPanel.getType());
									System.out.println("Image resized");
								}
								BufferedImage newimg=
										transformer.nonlinearTransformationPicture(ip.pictureOnPanel, expression1, expression2);
								ip.pictureOnPanel=newimg;
								ip.setRepairItemEnabled(true);
								
								ip.repaint();
	
							}
							else{
								JOptionPane.showMessageDialog(ip,
									    "Nincs transzformálandó kép",
									    "Transzformálási hiba",
									    JOptionPane.ERROR_MESSAGE);
							}
						}
					}
				}
				
			}
		});
		
		JPanel storagePanel4 = new JPanel();
		storagePanel4.setOpaque(true);
		
		GroupLayout layout4 = new GroupLayout(storagePanel4);
		storagePanel4.setLayout(layout4);
		layout4.setAutoCreateGaps(true);
		layout4.setAutoCreateContainerGaps(true);
		
		
		layout4.setHorizontalGroup(
				layout4.createSequentialGroup()
				.addGroup(layout4.createParallelGroup(GroupLayout.Alignment.LEADING)
						.addComponent(c28)
						.addComponent(c31)
						.addComponent(c33)
						)
				.addGroup(layout4.createParallelGroup(GroupLayout.Alignment.LEADING)
						.addComponent(c29)
						.addComponent(c30)
						)
				);
		layout4.setVerticalGroup(
				layout4.createSequentialGroup()
				.addGroup(layout4.createParallelGroup(GroupLayout.Alignment.BASELINE)
						.addComponent(c28)
						.addComponent(c29)
						)
				.addGroup(layout4.createParallelGroup(GroupLayout.Alignment.BASELINE)
						.addComponent(c33)
						.addComponent(c30)
						)
				//.addComponent(c30)
				.addComponent(c31)
				);
		
		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		
		this.add(c19);
		c19.setAlignmentX(CENTER_ALIGNMENT);
		this.add(c20);
		c20.setAlignmentX(CENTER_ALIGNMENT);
		this.add(storagePanel3);
		this.add(c27);
		c27.setAlignmentX(CENTER_ALIGNMENT);

		JPanel emptyPanel=new JPanel();
		emptyPanel.setPreferredSize(new Dimension(250,450));
		
		
		//this.add(Box.createRigidArea(new Dimension(0,5)));
		this.add(storagePanel4);
		this.add(emptyPanel);
		//this.add(Box.createRigidArea(new Dimension(0,5)));
		
	}
	
	
	private static BufferedImage resizeImageWithHint(
			BufferedImage originalImage, int type) {
		int imgwidth = 200;
		double imgheight_double = ((double) originalImage.getHeight() / (double) originalImage
				.getWidth()) * 200;
		int imgheight = (int) Math.round(imgheight_double);

		ImagePlus scaledImage = new ImagePlus();
		scaledImage.setImage(originalImage);
		ImageProcessor processor = scaledImage.getProcessor().resize(imgwidth,
				imgheight, true);

//		BufferedImage resizedImage = new BufferedImage(imgwidth, imgheight,
//				type);
//		Graphics2D g = resizedImage.createGraphics();
//		g.drawImage(originalImage, 0, 0, imgwidth, imgheight, null);
//		g.dispose();
//		g.setComposite(AlphaComposite.Src);
//
//		g.setRenderingHint(RenderingHints.KEY_INTERPOLATION,
//				RenderingHints.VALUE_INTERPOLATION_BILINEAR);
//		g.setRenderingHint(RenderingHints.KEY_RENDERING,
//				RenderingHints.VALUE_RENDER_QUALITY);
//		g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
//				RenderingHints.VALUE_ANTIALIAS_ON);

		return processor.getBufferedImage();
	}
}	
