package szakdolgozat;

import java.awt.Color;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.geom.Line2D;
import java.awt.geom.Point2D;
import java.awt.image.BufferedImage;

import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.GroupLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;



public class WorkspaceToolbarPanel extends JPanel{

	/**
	 * 
	 */
	private static final long serialVersionUID = 2599114988248523223L;
	private final WorkspacePanel cp;
	String regex="\\(-?[0-9]+\\.?[0-9]*,-?[0-9]+\\.?[0-9]*\\)";


	public WorkspaceToolbarPanel(WorkspacePanel cp_) {
		super();
		cp=cp_;
		setOpaque(true);
		setPreferredSize(new Dimension(250,560));
		//setBackground(new Color(255,240,245));

		JLabel c1 = new JLabel("Alakzat rajzolás");
		JLabel c2 = new JLabel("Pont: ");
		c2.setToolTipText("Pont megadása (x,y) formában.");
		final JTextField c3 = new JTextField();
		JLabel c4 = new JLabel("Szakasz: ");


		c4.setToolTipText("Egyenes megadása két pont segítségével. (x1,y1) (x2,y2)");
		final JTextField c5 = new JTextField();
		c5.setToolTipText("Pont megadása (x,y) formában.");
		final JTextField c6 = new JTextField();
		c6.setToolTipText("Pont megadása (x,y) formában.");
		JLabel c7 = new JLabel("Kör: ");
		c7.setToolTipText("Kör megadása középpontja és sugara alapján.");
		final JTextField c8 = new JTextField();
		c8.setToolTipText("Pont megadása (x,y) formában.");
		final JTextField c9 = new JTextField();
		c9.setToolTipText("Sugár megadása.");
		JLabel c10 = new JLabel("Négyszög: ");
		c10.setToolTipText("Négyszög megadása 4 csúcsa alapján.");
		final JTextField c11 = new JTextField();
		c11.setToolTipText("Pont megadása (x,y) formában.");
		final JTextField c12 = new JTextField();
		c12.setToolTipText("Pont megadása (x,y) formában.");
		final JTextField c13 = new JTextField();
		c13.setToolTipText("Pont megadása (x,y) formában.");
		final JTextField c14 = new JTextField();
		c14.setToolTipText("Pont megadása (x,y) formában.");
		JButton c15 = new JButton();
		c15.setText("Kirajzol");

		c15.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				if(!(c3.getText()).equals("")){
					if(c3.getText().matches(regex)){
						Point2D.Double point = stringToPoint(c3.getText());
						cp.addNewComponent(point);
					}
					else{
						JOptionPane.showMessageDialog(cp,
								"Helytelenül adta meg a pontot.\nA Pontot (x,y) alakban adja meg.",
								"Pontfelviteli hiba",
								JOptionPane.ERROR_MESSAGE);
					}
				}
				if(!(c5.getText().equals("")) && !(c6.getText().equals(""))){
					if(c5.getText().matches(regex) && c6.getText().matches(regex)){
						Point2D.Double P1 = stringToPoint(c5.getText());
						Point2D.Double P2 = stringToPoint(c6.getText());
						cp.addNewComponent(new Line2D.Double(P1,P2));
					}
					else{
						JOptionPane.showMessageDialog(cp,
								"Helytelenül adta meg a szakasz pontjait.\nA Pontot (x,y) alakban adja meg.",
								"Pontfelviteli hiba",
								JOptionPane.ERROR_MESSAGE);
					}
				}

				if(!(c8.getText().equals("")) && !(c9.getText().equals(""))){
					if(c8.getText().matches(regex) && c9.getText().matches("[0-9]+\\.?[0-9]*")){
						Point2D.Double P = stringToPoint(c8.getText());
						double r= Double.parseDouble(c9.getText());
						r=(double)(Math.round(r*10))/10;
						cp.addNewComponent(new MyCircle(P, r));
					}
					else{
						JOptionPane.showMessageDialog(cp,
								"Helytelenül adta meg a kör adatait.\nA Pontot (x,y) alakban adja meg, a sugár egy valós szám.",
								"Adatfelviteli hiba",
								JOptionPane.ERROR_MESSAGE);
					}
				}

				if(!(c11.getText().equals("")) && !(c12.getText().equals("")) &&
						!(c13.getText().equals("")) && !(c14.getText().equals(""))){

					if(c11.getText().matches(regex) && c12.getText().matches(regex) &&
							c13.getText().matches(regex) && c14.getText().matches(regex)){
						Point2D.Double P1 = stringToPoint(c11.getText());
						Point2D.Double P2 = stringToPoint(c12.getText());
						Point2D.Double P3 = stringToPoint(c13.getText());
						Point2D.Double P4 = stringToPoint(c14.getText());
						Point2D.Double[] polygonpoints={P1,P2,P3,P4};
						cp.addNewComponent(new MyPolygon(polygonpoints,polygonpoints.length));
					}
					else{
						JOptionPane.showMessageDialog(cp,
								"Helytelenül adta meg a négyszög csúcsait.\nA Pontot (x,y) alakban adja meg.",
								"Pontfelviteli hiba",
								JOptionPane.ERROR_MESSAGE);
					}

				}
				cp.repaint();

			}
		});

		JPanel storagePanel1= new JPanel();
		storagePanel1.setOpaque(true);
		GroupLayout layout = new GroupLayout(storagePanel1);
		storagePanel1.setLayout(layout);
		layout.setAutoCreateGaps(true);
		layout.setAutoCreateContainerGaps(true);

		layout.setHorizontalGroup(
				layout.createSequentialGroup()
				.addGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING)
						.addComponent(c2)
						.addComponent(c4)
						.addComponent(c7)
						.addComponent(c10)
						.addComponent(c15)
						)
						.addGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING)
								.addComponent(c3)
								.addComponent(c5)
								.addComponent(c8)
								.addComponent(c11)
								.addComponent(c13)
								)
								.addGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING)
										.addComponent(c6)
										.addComponent(c9)
										.addComponent(c12)
										.addComponent(c14)
										)
				);
		layout.setVerticalGroup(
				layout.createSequentialGroup()
				.addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
						.addComponent(c2)
						.addComponent(c3)
						)
						.addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
								.addComponent(c4)
								.addComponent(c5)
								.addComponent(c6)
								)
								.addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
										.addComponent(c7)
										.addComponent(c8)
										.addComponent(c9)
										)
										.addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
												.addComponent(c10)
												.addComponent(c11)
												.addComponent(c12)
												)
												.addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
														.addComponent(c13)
														.addComponent(c14)
														)
														.addComponent(c15)
				);

		JLabel c16 = new JLabel("Függvény: ");
		final JTextField c17 = new JTextField();
		c17.setToolTipText("Függvény megadása x ismeretlen használatával.");
		JButton c18 = new JButton();
		c18.setText("Kirajzol");

		c18.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				if(!c17.getText().equals("")){
					System.out.println(c17.getText());
					cp.addNewComponent(new MyFunction(c17.getText(),-70.0,70.0));
				}
				cp.repaint();
			}
		});


		JPanel storagePanel2 = new JPanel();
		storagePanel2.setOpaque(true);

		GroupLayout layout2 = new GroupLayout(storagePanel2);
		storagePanel2.setLayout(layout2);
		layout2.setAutoCreateGaps(true);
		layout2.setAutoCreateContainerGaps(true);

		layout2.setHorizontalGroup(
				layout2.createSequentialGroup()
				.addGroup(layout2.createParallelGroup(GroupLayout.Alignment.LEADING)
						.addComponent(c16)
						.addComponent(c18)
						)

						.addComponent(c17)
				);
		layout2.setVerticalGroup(
				layout2.createSequentialGroup()


				.addGroup(layout2.createParallelGroup(GroupLayout.Alignment.BASELINE)
						.addComponent(c16)
						.addComponent(c17)
						)
						.addComponent(c18)
				);


		JLabel c19 = new JLabel("Transzformáció");
		JLabel c20 = new JLabel("Lineáris transzformáció");

		JLabel c21 = new JLabel("Mátrix: ");
		final JTextField c22 = new JTextField();
		final JTextField c23 = new JTextField();
		final JTextField c24 = new JTextField();
		final JTextField c25 = new JTextField();
		JButton c26 = new JButton();
		c26.setText("Transzformál");

		JPanel storagePanelForTheColorsOfLinTransf= new JPanel();
		storagePanelForTheColorsOfLinTransf.setOpaque(true);

		FlowLayout layoutforThePalette = new FlowLayout();
		storagePanelForTheColorsOfLinTransf.setLayout(layoutforThePalette);

		final JRadioButton red =new JRadioButton(new ImageIcon(createColorImage(Color.RED)));
		final JRadioButton green =new JRadioButton(new ImageIcon(createColorImage(Color.GREEN)));
		final JRadioButton blue =new JRadioButton(new ImageIcon(createColorImage(Color.BLUE)));
		final JRadioButton orange =new JRadioButton(new ImageIcon(createColorImage(Color.ORANGE)));

		ButtonGroup group = new ButtonGroup();
		group.add(red);
		group.add(green);
		group.add(blue);
		group.add(orange);
		red.setSelected(true);
		red.setBackground(Color.BLACK);

		red.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				red.setBackground(Color.BLACK);
				red.setSelected(true);
				green.setBackground(null);
				blue.setBackground(null);
				orange.setBackground(null);
				cp.setLinTransformationColor(Color.RED);
			}
		});
		green.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				green.setBackground(Color.BLACK);
				green.setSelected(true);
				red.setBackground(null);
				blue.setBackground(null);
				orange.setBackground(null);
				cp.setLinTransformationColor(Color.GREEN);
			}
		});
		blue.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				blue.setBackground(Color.BLACK);
				blue.setSelected(true);
				green.setBackground(null);
				red.setBackground(null);
				orange.setBackground(null);
				cp.setLinTransformationColor(Color.BLUE);
			}
		});
		orange.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				orange.setBackground(Color.BLACK);
				orange.setSelected(true);
				green.setBackground(null);
				blue.setBackground(null);
				red.setBackground(null);
				cp.setLinTransformationColor(Color.ORANGE);
			}
		});
		storagePanelForTheColorsOfLinTransf.add(c26);
		storagePanelForTheColorsOfLinTransf.add(red);
		storagePanelForTheColorsOfLinTransf.add(blue);
		storagePanelForTheColorsOfLinTransf.add(green);
		storagePanelForTheColorsOfLinTransf.add(orange);


		JPanel storagePanel3 = new JPanel();
		storagePanel3.setOpaque(true);


		GroupLayout layout3 = new GroupLayout(storagePanel3);
		storagePanel3.setLayout(layout3);
		layout3.setAutoCreateGaps(true);
		layout3.setAutoCreateContainerGaps(true);

		layout3.setHorizontalGroup(
				layout3.createSequentialGroup()
				//.addGroup(layout3.createParallelGroup(GroupLayout.Alignment.LEADING)
				.addComponent(c21)
				//.addComponent(c26)
				//	)
				.addGroup(layout3.createParallelGroup(GroupLayout.Alignment.LEADING)
						.addComponent(c22)
						.addComponent(c24)
						//.addComponent(red)

						)
						.addGroup(layout3.createParallelGroup(GroupLayout.Alignment.LEADING)
								.addComponent(c23)
								.addComponent(c25)
								//.addComponent(blue)
								)
				);
		layout3.setVerticalGroup(
				layout3.createSequentialGroup()
				.addGroup(layout3.createParallelGroup(GroupLayout.Alignment.BASELINE)
						.addComponent(c21)
						.addComponent(c22)
						.addComponent(c23)
						)
						.addGroup(layout3.createParallelGroup(GroupLayout.Alignment.BASELINE)
								.addComponent(c24)
								.addComponent(c25)
								)
								//.addGroup(layout3.createParallelGroup(GroupLayout.Alignment.BASELINE)
								//		.addComponent(c26)
								//.addComponent(red)
								//.addComponent(blue))

				);


		c26.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				if(!c22.getText().equals("") && !c23.getText().equals("") && !c24.getText().equals("") && !c25.getText().equals("")){
					if(c22.getText().matches("-?[0-9]+\\.?[0-9]*") && c23.getText().matches("-?[0-9]+\\.?[0-9]*") && c24.getText().matches("-?[0-9]+\\.?[0-9]*")
							&& c25.getText().matches("-?[0-9]+\\.?[0-9]*")){

						cp.linearTransformation(Integer.parseInt(c22.getText()), Integer.parseInt(c23.getText()),
								Integer.parseInt(c24.getText()), Integer.parseInt(c25.getText()));

					}
					else {
						JOptionPane.showMessageDialog(cp,
								"Helytelenül adta meg a mátrixot.",
								"Mátrix hiba",
								JOptionPane.ERROR_MESSAGE);
					}
				}

			}
		});

		JLabel c27 = new JLabel("Nemlineáris transzformáció");

		JLabel c28 = new JLabel("Képlet:  f(x,y)");
		JLabel c33 = new JLabel("                  g(x,y)");
		c28.setToolTipText("Transzformáció megadása f(x,y) g(x,y) formában.");
		final JTextField c29 = new JTextField();
		c29.setToolTipText("A transzformáció x koordinátára vonatkozó képlete: x'=f(x,y) ");
		final JTextField c30 = new JTextField();
		c30.setToolTipText("A transzformáció y koordinátára vonatkozó képlete: y'=g(x,y) ");
		JButton c31 = new JButton();
		c31.setText("Transzformál");
		MyKeyListener mk=new MyKeyListener(c29);
		mk.start();
		MyKeyListener mk2=new MyKeyListener(c30);
		mk2.start();
		c31.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				if(!c29.getText().equals("") && !c30.getText().equals("")){

					int szamlalo=0;
					for(int i=0;i<c29.getText().length();i++){
						if(c29.getText().charAt(i)=='('){
							szamlalo++;
						}
						if(c29.getText().charAt(i)==')'){
							szamlalo--;
						}
					}
					if(szamlalo!=0){
						JOptionPane.showMessageDialog(cp,
								"Hibás zárójelezés f(x,y) megadásakor.",
								"Zárójel hiba",
								JOptionPane.ERROR_MESSAGE);
					}
					else{
						szamlalo=0;
						for(int i=0;i<c30.getText().length();i++){
							if(c30.getText().charAt(i)=='('){
								szamlalo++;
							}
							if(c30.getText().charAt(i)==')'){
								szamlalo--;
							}
						}
						if(szamlalo!=0){
							JOptionPane.showMessageDialog(cp,
									"Hibás zárójelezés g(x,y) megadásakor.",
									"Zárójel hiba",
									JOptionPane.ERROR_MESSAGE);
						}
						else{
							cp.setCursor(new Cursor(Cursor.WAIT_CURSOR));
							cp.nonlinearTransformation(c29.getText(), c30.getText());
							cp.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
						}
					}
				}

			}
		});

		JPanel storagePanel4 = new JPanel();
		storagePanel4.setOpaque(true);

		GroupLayout layout4 = new GroupLayout(storagePanel4);
		storagePanel4.setLayout(layout4);
		layout4.setAutoCreateGaps(true);
		layout4.setAutoCreateContainerGaps(true);


		layout4.setHorizontalGroup(
				layout4.createSequentialGroup()
				.addGroup(layout4.createParallelGroup(GroupLayout.Alignment.LEADING)
						.addComponent(c28)
						//.addComponent(c31)
						.addComponent(c33)
						)
						.addGroup(layout4.createParallelGroup(GroupLayout.Alignment.LEADING)
								.addComponent(c29)
								.addComponent(c30)
								)
				);
		layout4.setVerticalGroup(
				layout4.createSequentialGroup()
				.addGroup(layout4.createParallelGroup(GroupLayout.Alignment.BASELINE)
						.addComponent(c28)
						.addComponent(c29)
						)
						//.addComponent(c30)
						.addGroup(layout4.createParallelGroup(GroupLayout.Alignment.BASELINE)
								.addComponent(c33)
								.addComponent(c30)
								)
								//.addComponent(c31)
				);

		JPanel storagePanelForTheColorsOfNonLinTransf= new JPanel();
		storagePanelForTheColorsOfNonLinTransf.setOpaque(true);

		FlowLayout layoutforThePaletteNonLintraf = new FlowLayout();
		storagePanelForTheColorsOfNonLinTransf.setLayout(layoutforThePaletteNonLintraf);

		final JRadioButton rednlt =new JRadioButton(new ImageIcon(createColorImage(Color.RED)));
		final JRadioButton greennlt =new JRadioButton(new ImageIcon(createColorImage(Color.GREEN)));
		final JRadioButton bluenlt =new JRadioButton(new ImageIcon(createColorImage(Color.BLUE)));
		final JRadioButton orangenlt =new JRadioButton(new ImageIcon(createColorImage(Color.ORANGE)));

		ButtonGroup groupNonLin = new ButtonGroup();
		groupNonLin.add(rednlt);
		groupNonLin.add(greennlt);
		groupNonLin.add(bluenlt);
		groupNonLin.add(orangenlt);
		bluenlt.setSelected(true);
		bluenlt.setBackground(Color.BLACK);

		rednlt.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				rednlt.setBackground(Color.BLACK);
				rednlt.setSelected(true);
				greennlt.setBackground(null);
				bluenlt.setBackground(null);
				orangenlt.setBackground(null);
				cp.setNonLinTransformationColor(Color.RED);
			}
		});
		greennlt.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				greennlt.setBackground(Color.BLACK);
				greennlt.setSelected(true);
				rednlt.setBackground(null);
				bluenlt.setBackground(null);
				orangenlt.setBackground(null);
				cp.setNonLinTransformationColor(Color.GREEN);
			}
		});
		bluenlt.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				bluenlt.setBackground(Color.BLACK);
				bluenlt.setSelected(true);
				greennlt.setBackground(null);
				rednlt.setBackground(null);
				orangenlt.setBackground(null);
				cp.setNonLinTransformationColor(Color.BLUE);
			}
		});
		orangenlt.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				orangenlt.setBackground(Color.BLACK);
				orangenlt.setSelected(true);
				greennlt.setBackground(null);
				bluenlt.setBackground(null);
				rednlt.setBackground(null);
				cp.setNonLinTransformationColor(Color.ORANGE);
			}
		});
		storagePanelForTheColorsOfNonLinTransf.add(c31);
		storagePanelForTheColorsOfNonLinTransf.add(bluenlt);
		storagePanelForTheColorsOfNonLinTransf.add(rednlt);
		storagePanelForTheColorsOfNonLinTransf.add(greennlt);
		storagePanelForTheColorsOfNonLinTransf.add(orangenlt);

		JPanel emptyPanel=new JPanel();
		emptyPanel.setPreferredSize(new Dimension(250,200));



		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));

		this.add(c1);
		c1.setAlignmentX(CENTER_ALIGNMENT);
		this.add(storagePanel1);
		this.add(storagePanel2);


		this.add(c19);
		c19.setAlignmentX(CENTER_ALIGNMENT);
		this.add(c20);
		c20.setAlignmentX(CENTER_ALIGNMENT);
		this.add(storagePanel3);
		this.add(storagePanelForTheColorsOfLinTransf);
		this.add(c27);
		c27.setAlignmentX(CENTER_ALIGNMENT);



		//this.add(Box.createRigidArea(new Dimension(0,5)));
		this.add(storagePanel4);
		this.add(storagePanelForTheColorsOfNonLinTransf);
		this.add(emptyPanel);
		//this.add(Box.createRigidArea(new Dimension(0,5)));

	}

	public static Point2D.Double stringToPoint(String s){
		if(s!=null){
			String xPoint = "";
			String yPoint = "";

			int i;
			for(i=1;i<s.length() && isSzam(s.charAt(i));){
				xPoint+=s.charAt(i);
				i++;
			}
			i++;
			System.out.println(i);
			for(;i<s.length() && isSzam(s.charAt(i));){
				yPoint+=s.charAt(i);
				i++;
			}
			System.out.println(i);
			System.out.println(xPoint);
			System.out.println(yPoint);

			double x = Double.parseDouble(xPoint);
			double y = Double.parseDouble(yPoint);

			x=(double)(Math.round(x*10))/10;
			y=(double)(Math.round(y*10))/10;

			return new Point2D.Double(x,y);
		}
		else{
			return null;
		}
	}

	public static boolean isSzam(char c){
		if((c>='0' && c<='9') || c=='.' || c=='-'){
			return true;
		}
		else{
			return false;
		}
	}

	private BufferedImage createColorImage(Color color){
		BufferedImage colorImage=new BufferedImage(16, 16, BufferedImage.TYPE_INT_RGB);
		for(int i=0;i<16;i++){
			for(int j=0;j<16;j++){
				colorImage.setRGB(i, j, color.getRGB());
			}
		}
		return colorImage;
	}

}
